Index: palm/trunk/SOURCE/parin.f90
===================================================================
--- palm/trunk/SOURCE/parin.f90	(revision 407)
+++ palm/trunk/SOURCE/parin.f90	(revision 410)
@@ -5,4 +5,9 @@
 ! -----------------
 ! +wall_humidityflux, wall_scalarflux
+!
+! Branch revisions:
+! -----------------
+! Masked data output: + dt_domask, mask_01~20_x|y|z, mask_01~20_x|y|z_loop, 
+! mask_scale_x|y|z, masks, netcdf_format_mask[_av], skip_time_domask
 !
 ! Former revisions:
@@ -108,5 +113,5 @@
              lad_vertical_gradient, lad_vertical_gradient_level, &
              leaf_surface_concentration, long_filter_factor, &
-             loop_optimization, mixing_length_1d, momentum_advec, &
+             loop_optimization, mixing_length_1d, masks, momentum_advec, &
              netcdf_precision, nsor_ini, nx, ny, &
              nz, ocean, omega, outflow_damping_width, overshoot_limit_e, &
@@ -140,5 +145,16 @@
                        cross_normalized_y, cross_profiles, cross_ts_uymax, &
                        cross_ts_uymin, cross_xtext, cycle_mg, data_output, &
-                       data_output_format, data_output_pr, &
+                       data_output_format, &
+                       data_output_mask_01, data_output_mask_02, &
+                       data_output_mask_03, data_output_mask_04, &
+                       data_output_mask_05, data_output_mask_06, &
+                       data_output_mask_07, data_output_mask_08, &
+                       data_output_mask_09, data_output_mask_10, &
+                       data_output_mask_11, data_output_mask_12, &
+                       data_output_mask_13, data_output_mask_14, &
+                       data_output_mask_15, data_output_mask_16, &
+                       data_output_mask_17, data_output_mask_18, &
+                       data_output_mask_19, data_output_mask_20, &
+                       data_output_pr, &
                        data_output_2d_on_each_pe, disturbance_amplitude, &
                        disturbance_energy_limit, disturbance_level_b, &
@@ -146,9 +162,48 @@
                        do3d_compress, do3d_comp_prec, dt, dt_averaging_input, &
                        dt_averaging_input_pr, dt_coupling, dt_data_output, &
-                       dt_data_output_av, dt_disturb, dt_dopr, &
+                       dt_data_output_av, dt_disturb, dt_domask, dt_dopr, &
                        dt_dopr_listing, dt_dots, dt_do2d_xy, dt_do2d_xz, &
                        dt_do2d_yz, dt_do3d, dt_max, dt_restart, dt_run_control,&
-                       end_time, force_print_header, mg_cycles, &
-                       mg_switch_to_pe0_level, netcdf_64bit, netcdf_64bit_3d, &
+                       end_time, force_print_header, &
+                       mask_scale_x, mask_scale_y, mask_scale_z, &
+                       mask_01_x, mask_02_x, mask_03_x, mask_04_x, &
+                       mask_05_x, mask_06_x, mask_07_x, mask_08_x, &
+                       mask_09_x, mask_10_x, mask_11_x, mask_12_x, &
+                       mask_13_x, mask_14_x, mask_15_x, mask_16_x, &
+                       mask_17_x, mask_18_x, mask_19_x, mask_20_x, &
+                       mask_01_y, mask_02_y, mask_03_y, mask_04_y, &
+                       mask_05_y, mask_06_y, mask_07_y, mask_08_y, &
+                       mask_09_y, mask_10_y, mask_11_y, mask_12_y, &
+                       mask_13_y, mask_14_y, mask_15_y, mask_16_y, &
+                       mask_17_y, mask_18_y, mask_19_y, mask_20_y, &
+                       mask_01_z, mask_02_z, mask_03_z, mask_04_z, &
+                       mask_05_z, mask_06_z, mask_07_z, mask_08_z, &
+                       mask_09_z, mask_10_z, mask_11_z, mask_12_z, &
+                       mask_13_z, mask_14_z, mask_15_z, mask_16_z, &
+                       mask_17_z, mask_18_z, mask_19_z, mask_20_z, &
+                       mask_01_x_loop, mask_02_x_loop, mask_03_x_loop, &
+                       mask_04_x_loop, mask_05_x_loop, mask_06_x_loop, &
+                       mask_07_x_loop, mask_08_x_loop, mask_09_x_loop, &
+                       mask_10_x_loop, mask_11_x_loop, mask_12_x_loop, &
+                       mask_13_x_loop, mask_14_x_loop, mask_15_x_loop, &
+                       mask_16_x_loop, mask_17_x_loop, mask_18_x_loop, &
+                       mask_19_x_loop, mask_20_x_loop, &
+                       mask_01_y_loop, mask_02_y_loop, mask_03_y_loop, &
+                       mask_04_y_loop, mask_05_y_loop, mask_06_y_loop, &
+                       mask_07_y_loop, mask_08_y_loop, mask_09_y_loop, &
+                       mask_10_y_loop, mask_11_y_loop, mask_12_y_loop, &
+                       mask_13_y_loop, mask_14_y_loop, mask_15_y_loop, &
+                       mask_16_y_loop, mask_17_y_loop, mask_18_y_loop, &
+                       mask_19_y_loop, mask_20_y_loop, &
+                       mask_01_z_loop, mask_02_z_loop, mask_03_z_loop, &
+                       mask_04_z_loop, mask_05_z_loop, mask_06_z_loop, &
+                       mask_07_z_loop, mask_08_z_loop, mask_09_z_loop, &
+                       mask_10_z_loop, mask_11_z_loop, mask_12_z_loop, &
+                       mask_13_z_loop, mask_14_z_loop, mask_15_z_loop, &
+                       mask_16_z_loop, mask_17_z_loop, mask_18_z_loop, &
+                       mask_19_z_loop, mask_20_z_loop, &
+                       mg_cycles, mg_switch_to_pe0_level, &
+                       netcdf_64bit, netcdf_64bit_3d, &
+                       netcdf_format_mask, netcdf_format_mask_av, &
                        ngsrb, normalizing_region, npex, npey, nsor, nz_do3d, &
                        omega_sor, &
@@ -160,5 +215,5 @@
                        skip_time_data_output_av, skip_time_dopr, &
                        skip_time_do2d_xy, skip_time_do2d_xz, &
-                       skip_time_do2d_yz, skip_time_do3d, &
+                       skip_time_do2d_yz, skip_time_do3d, skip_time_domask, &
                        termination_time_needed, use_prior_plot1d_parameters, &
                        z_max_do1d, z_max_do1d_normalized, z_max_do2d
Index: palm/trunk/SOURCE/production_e.f90
===================================================================
--- palm/trunk/SOURCE/production_e.f90	(revision 407)
+++ palm/trunk/SOURCE/production_e.f90	(revision 410)
@@ -635,5 +635,5 @@
        USE indices
        USE statistics
-
+USE pegrid
        IMPLICIT NONE
 
@@ -988,4 +988,7 @@
 
                 DO  k = nzb_diff_s_inner(j,i), nzt_diff
+IF ( pt(k,j,i) == 0.0 .OR. dd2zu(k) == 0.0 )  &
+WRITE (*,'(6(I4,1X),F6.2,1X,F6.2)')  &
+myid, i, j, nzb_diff_s_inner(j,i), nzt_diff, k, pt(k,j,i), dd2zu(k)
                    tend(k,j,i) = tend(k,j,i) - kh(k,j,i) * g / pt(k,j,i) * &
                                        ( pt(k+1,j,i) - pt(k-1,j,i) ) * dd2zu(k)
Index: palm/trunk/SOURCE/read_3d_binary.f90
===================================================================
--- palm/trunk/SOURCE/read_3d_binary.f90	(revision 407)
+++ palm/trunk/SOURCE/read_3d_binary.f90	(revision 410)
@@ -181,5 +181,5 @@
           DO  k = 1, j
              WRITE (9,*) 'k = ', k
-             WRITE (9,'(6(A,I2))')  'nxlfa = ', nxlfa(files_to_be_opened,k), &
+             WRITE (9,'(6(A,I4))')  'nxlfa = ', nxlfa(files_to_be_opened,k), &
                          ' nxrfa = ', nxrfa(files_to_be_opened,k), &
                          ' offset_xa = ', offset_xa(files_to_be_opened,k), &
Index: palm/trunk/SOURCE/time_integration.f90
===================================================================
--- palm/trunk/SOURCE/time_integration.f90	(revision 407)
+++ palm/trunk/SOURCE/time_integration.f90	(revision 410)
@@ -5,4 +5,8 @@
 ! -----------------
 ! Bugfix: exchange of ghost points for prho included
+!
+! Branch revisions:
+! -----------------
+! masked data output
 !
 ! Former revisions:
@@ -324,4 +328,9 @@
           time_do3d          = time_do3d        + dt_3d
        ENDIF
+       DO  mid = 1, masks
+          IF ( simulated_time >= skip_time_domask(mid) )  THEN
+             time_domask(mid)= time_domask(mid) + dt_3d
+          ENDIF
+       ENDDO
        time_dvrp          = time_dvrp        + dt_3d
        IF ( simulated_time >= skip_time_dosp )  THEN
@@ -399,5 +408,5 @@
 
 !
-!--    Sum-up 3d-arrays for later output of time-averaged data
+!--    Sum-up 3d-arrays for later output of time-averaged 2d/3d/masked data
        IF ( averaging_interval /= 0.0  .AND.                                &
             ( dt_data_output_av - time_do_av ) <= averaging_interval  .AND. &
@@ -495,5 +504,15 @@
 
 !
-!--    Output of time-averaged 2d/3d-data
+!--    masked data output
+       DO  mid = 1, masks
+          IF ( time_domask(mid) >= dt_domask(mid) )  THEN
+             CALL data_output_mask( 0 )
+             time_domask(mid) = MOD( time_domask(mid),  &
+                                     MAX( dt_domask(mid), dt_3d ) )
+          ENDIF
+       ENDDO
+
+!
+!--    Output of time-averaged 2d/3d/masked data
        IF ( time_do_av >= dt_data_output_av )  THEN
           CALL average_3d_data
@@ -502,4 +521,7 @@
           CALL data_output_2d( 'yz', 1 )
           CALL data_output_3d( 1 )
+          DO  mid = 1, masks
+             CALL data_output_mask( 1 )
+          ENDDO
           time_do_av = MOD( time_do_av, MAX( dt_data_output_av, dt_3d ) )
        ENDIF
Index: palm/trunk/SOURCE/user_data_output_mask.f90
===================================================================
--- palm/trunk/SOURCE/user_data_output_mask.f90	(revision 410)
+++ palm/trunk/SOURCE/user_data_output_mask.f90	(revision 410)
@@ -0,0 +1,72 @@
+ SUBROUTINE user_data_output_mask( av, variable, found, local_pf )
+
+!------------------------------------------------------------------------------!
+! Current revisions:
+! ------------------
+! 
+!
+! Former revisions:
+! -----------------
+! $Id$
+! Initial version
+!
+! Description:
+! ------------
+! Resorts the user-defined output quantity with indices (k,j,i) to a
+! temporary array with indices (i,j,k) for masked data output.
+!------------------------------------------------------------------------------!
+
+    USE control_parameters
+    USE indices
+    USE user
+
+    IMPLICIT NONE
+
+    CHARACTER (LEN=*) ::  variable
+
+    INTEGER ::  av, i, j, k
+
+    LOGICAL ::  found
+
+    REAL, DIMENSION(mask_size_l(mid,1),mask_size_l(mid,2), &
+                    mask_size_l(mid,3)) ::  local_pf
+
+
+    found = .TRUE.
+
+    SELECT CASE ( TRIM( variable ) )
+
+!
+!--    Uncomment and extend the following lines, if necessary.
+!--    The arrays for storing the user defined quantities (here u2 and u2_av)
+!--    have to be declared and defined by the user!
+!--    Sample for user-defined output:
+!       CASE ( 'u2' )
+!          IF ( av == 0 )  THEN
+!            DO  i = 1, mask_size_l(mid,1)
+!               DO  j = 1, mask_size_l(mid,2)
+!                  DO  k = 1, mask_size_l(mid,3)
+!                      local_pf(i,j,k) = u2(mask_k(mid,k), &
+!                                           mask_j(mid,j),mask_i(mid,i))
+!                   ENDDO
+!                ENDDO
+!             ENDDO
+!          ELSE
+!            DO  i = 1, mask_size_l(mid,1)
+!               DO  j = 1, mask_size_l(mid,2)
+!                  DO  k = 1, mask_size_l(mid,3)
+!                      local_pf(i,j,k) = u2_av(mask_k(mid,k), &
+!                                              mask_j(mid,j),mask_i(mid,i))
+!                   ENDDO
+!                ENDDO
+!             ENDDO
+!          ENDIF
+!
+
+       CASE DEFAULT
+          found = .FALSE.
+
+    END SELECT
+
+
+ END SUBROUTINE user_data_output_mask
Index: palm/trunk/SOURCE/user_parin.f90
===================================================================
--- palm/trunk/SOURCE/user_parin.f90	(revision 407)
+++ palm/trunk/SOURCE/user_parin.f90	(revision 410)
@@ -5,4 +5,8 @@
 ! -----------------
 ! 
+!
+! Branch revisions:
+! -----------------
+! masked data output
 !
 ! Former revisions:
@@ -35,5 +39,15 @@
 
 
-    NAMELIST /userpar/  data_output_pr_user, data_output_user, region
+    NAMELIST /userpar/  data_output_pr_user, data_output_user, region,  &
+                        data_output_mask_user_01, data_output_mask_user_02, &
+                        data_output_mask_user_03, data_output_mask_user_04, &
+                        data_output_mask_user_05, data_output_mask_user_06, &
+                        data_output_mask_user_07, data_output_mask_user_08, &
+                        data_output_mask_user_09, data_output_mask_user_10, &
+                        data_output_mask_user_11, data_output_mask_user_12, &
+                        data_output_mask_user_13, data_output_mask_user_14, &
+                        data_output_mask_user_15, data_output_mask_user_16, &
+                        data_output_mask_user_17, data_output_mask_user_18, &
+                        data_output_mask_user_19, data_output_mask_user_20
 
 !
